using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;

namespace LD10Tanks
{
    public class BackgroundMesh
    {
        private const float BackgroundRadius = 15.0f;

        public VertexPositionNormalColor[] vtx;
        public int[] idx;

        public BackgroundMesh()
        {
            float cell_size = 0.5f;
            Vector3 bound = new Vector3(1.0f + cell_size * 2, 1.0f + cell_size * 2, 1.0f + cell_size * 2);

            MarchingCubes tri_gen = new MarchingCubes(new BoundingBox(-bound, bound), cell_size);
            EvalLevel level = new EvalLevel();

            level.StartPoints.Add(Vector3.Zero);
            level.FieldSolid.AddSphere(Vector3.Zero, 1.0f);
            tri_gen.Generate(level);

            vtx = tri_gen.Vertices.ToArray();
            idx = tri_gen.Triangles.ToArray();

            // Scale the mesh
            for (int i = 0; i < vtx.Length; ++i)
            {
                vtx[i].Position *= BackgroundRadius;
                vtx[i].Normal *= -1.0f;
                vtx[i].Color = new Color(new Vector3(0.3f, 0.561f, 0.123f));
            }

            // Flip the triangles (so they won't be culled)
            for (int i = 0; i < idx.Length; i += 3)
            {
                int tmp = idx[i];
                idx[i] = idx[i + 1];
                idx[i + 1] = tmp;
            }

            tri_gen = null;
            GC.Collect();
        }
    }
}
