using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;

namespace LD10Tanks
{
    public class EvalLevel
    {
        public List<Vector3> StartPoints = new List<Vector3>();

        public EvalField FieldSolid = new EvalField();
        public EvalField FieldExclude = new EvalField();

        public void Clear()
        {
            StartPoints.Clear();
            FieldSolid.Clear();
            FieldExclude.Clear();
        }

        public bool IsInside(ref Vector3 pt)
        {
            return FieldSolid.IsInside(ref pt) && !FieldExclude.IsInside(ref pt);
        }

        public void CopyFrom(EvalLevel src)
        {
            Clear();
            StartPoints.AddRange(src.StartPoints);
            FieldSolid.CopyFrom(src.FieldSolid);
            FieldExclude.CopyFrom(src.FieldExclude);
        }
    }
}
